#include "external/callback.h"
#include "external/logger.h"

bool deleted = false;

class A {
 public:
  A(int y):x(y){}
  
  void SetX(int y){
    x = y;
  }
  
  int X(){
    return x;
  }
  
  ~A(){
    deleted = true;
  }
 
 private:
  int x;
};

int t = 1;

void fun(int a){
  t = a;
}


int main(){
  CHECK(!deleted);
  A* x = new A(5);
  internal::MakeDeleter(x);
  CHECK(deleted);
  A a(1);
  Closure *c = NewCallback(fun, 2);
  CHECK_EQ(t, 1);
  c->Run();
  CHECK_EQ(t, 2);
  c = NewCallback(&a, &A::SetX, 2);
  CHECK_EQ(a.X(), 1);
  c->Run();
  CHECK_EQ(a.X(), 2);
  ReturnClosure<int>* rc = NewReturnCallback(&a, &A::X);
  CHECK_EQ(rc->Run(), 2);
  return 0;
}
